=== Applications/CMakeLists.txt ===
if (PARAVIEW_BUILD_QT_GUI)
  add_subdirectory(ParaView)
endif ()
