=== debian/changelog ===
paraview (5.7.0-4ubuntu9) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:25:13 +0100

paraview (5.7.0-4ubuntu8) focal; urgency=medium

  * No-change upload for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:04:52 +0100

paraview (5.7.0-4ubuntu7) focal; urgency=medium

  * No-change rebuild for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:02:16 +0100

paraview (5.7.0-4ubuntu6) focal; urgency=medium

  * Fix build on armhf by restoring a reworked fix_opengl_arm.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 08 Jan 2020 10:20:00 +0100

paraview (5.7.0-4ubuntu3) focal; urgency=medium

  * Minimize debug symbols to -g1
  * Disable parallel builds

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 06 Jan 2020 23:16:56 +0100

paraview (5.7.0-4) unstable; urgency=medium

  [ Gilles Filippini ]
  * New patch libatomic.patch: tentative fix for FTBFS on armel and mipsel.
    Closes: #947280
  * Hard-code Build-Dep on python3.8-dev. This wasn't being pulled in correctly
    leading to FTBFS. Closes: #946758

  [ Alastair McKinstry ]
  * python vtk now works. Closes: #823529
  * Fix warnings with 'is' and literals in python3.8+

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Dec 2019 16:21:57 +0000

paraview (5.7.0-3) unstable; urgency=medium

  * Hard-code Build-Dep on python3.8-dev. This wasn't being pulled in correctly
    leading to FTBFS.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 11 Dec 2019 09:16:00 +0000

paraview (5.7.0-2) unstable; urgency=medium

  * Rename paraview-python to standard python3-paraview. Closes: #944324
  * paraview-doc now Multi-Arch: foreign
  * Disable OpenGL features that are not available on Arm to 
    fix FTBFS. Closes: #944353
  * Update options thanks to Mathieu Westphal:
  * Now include PDAL support. Depend on libpdal-dev
  * Now include LZ4 support. Depend on liblz4-dev
  * Run autopkgtest with python3. Closes: #944533
  * Include vtkmodules in python3-paraview. Closes: #944582
  * Change paraview-dev dep from Qt4-dev-tools to qt5tools-dev-tools
  * Drop unnecessary deps on python3, python3-vtk in python3-paraview
  * python3.8.patch: Update mpi4py.MPI.c with latest cython for python3.8

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 17 Nov 2019 18:31:26 +0000

paraview (5.7.0-1) unstable; urgency=medium

  * New upstream release. Closes: #875086, #937239
   -  This release contains vendored third-party libraries
      until vtk8 packaged
  * Use debhelper-compat (=12 )
  * Add ${python3:Depends} in paraview
  * Standards-Version: 4.4.1.0
  * Update install paths

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Oct 2019 21:23:40 +0100
